Sun May 30 16:49:12 1993  Per Bothner  (bothner@cygnus.com)

	* unistd.h: Fix typo R_K -> R_OK.

Mon May  3 14:27:47 1993  Per Bothner  (bothner@cygnus.com)

	* time.h:  Fix protection against multiple inclusion.
	* sys/signal.h:  Check if included implicitly by
	/usr/include/signal.h (as under Irix 4.0.5).
	* stdlib.h (bsearch):  Fix return value.
	* stdlib.h (getopt):  Protect with _G_ARGS (needed for Irix).

Fri Apr 16 16:15:59 1993  Per Bothner  (bothner@cygnus.com)

	* curses.h (newwin, subwin):  Remove formal parameter names in
	prototypes - they can clash with macros.
	* math.h (finite):  Fix to return int, not double.
	* stdio.h (fgets):  Protect with _G_ARGS.
	* stdlib.h (stroul):  Remove bogus function.
	* stdlib.h (strtoul), unistd.h (lockf):  Add.

Mon Jan 11 12:18:15 1993  Brendan Kehoe  (brendan@cygnus.com)

	* stdio.h (remove): Undefine after including system stdio.h for SCO.

Mon Dec 28 14:26:20 1992  Ian Lance Taylor  (ian@cygnus.com)

	* curses.h: use _G_CURSES_FORMAT_ARG, from _G_config.h, rather
	than trying to guess the value.

Tue Dec 22 14:48:35 1992  Per Bothner  (bothner@rtl.cygnus.com)

	* math.h (scalb), curses.h (waddstr):  Use _G_ARGS,
	to avoid proptype conflicts.

Tue Nov 17 21:43:19 1992  Per Bothner  (bothner@rtl.cygnus.com)

	* curses.h:  Added patch for HPUX.
	* grp.h, memory.h, unistd.h: Added patches for OSF1.
	* math.h:  Fix definitions of isnan() and isinf() ANSI
	constants; #include <float.h> to support this.

Thu Nov 12 15:49:17 1992  Per Bothner  (bothner@rtl.cygnus.com)

	* sys/select.h:  New file.

Thu Sep 10 22:46:37 1992  Ian Lance Taylor  (ian@cygnus.com)

	* curses.h: only include the system <curses.h> if the new
	configuration flag _G_HAVE_CURSES is true.

Wed Aug 12 00:43:48 1992  Per Bothner  (bothner@cygnus.com)

	* sys/dir.h:  As is ./direct.h, remove definition for rewinddir
	(because it it often macro, which causes problems).
	* sys/stat.h:  Define S_ISLNK if needed and defined(S_IFLNK).
	* unistd.h (execv*), signal.h (psignal):  Fix prototypes.

Fri Jun 26 11:34:02 1992  Per Bothner  (bothner@rtl.cygnus.com)

	* curses.h:  Kludges to handle both VMS and SVR4 ...

Tue Jun 23 23:53:15 1992  Per Bothner  (bothner@cygnus.com)

	* direct.h, sys/dir.h:  Kludge to deal with AIX brain-damage.

Fri Jun 19 23:12:15 1992  Per Bothner  (bothner@cygnus.com)

	* unistd.h:  Change return types of read() and write()
	to _G_ssize_t, following latest Posix standard.

Thu Jun 18 16:22:12 1992  Per Bothner  (bothner@rtl.cygnus.com)

	* curses.h:  More SVR4 kludges (from Fred Fish).

Wed Jun 17 18:40:57 1992  Per Bothner  (bothner@rtl.cygnus.com)

	* curses.h:  Kludges for SVR4 portability.
	* stdlib.h:  Fix getopt() prototype.
	* string.h:  Add a comment pointing out the conflicts
	here are probably due to bad SIZE_TYPE in gcc.
	* time.h, sys/socket.h:  Protect various functions from
	prototype mismatch with _G_ARGS.  ALso, fix some typings.
	* unistd.h:  Lots of little "fixes" for improved portability.

Wed Jun  3 23:20:21 1992  Per Bothner  (bothner@rtl.cygnus.com)

	* sys/wait.h:  If !_G_HAVE_SYS_WAIT, define the Posix
	macros assuming "traditional" wait() structure.
	* unistd.h:  Use Posix types where appropriate.

Fri May 29 12:46:57 1992  Per Bothner  (bothner@rtl.cygnus.com)

	* stdio.h:  Typo: _G_sprint_return_type -> _G_sprintf_return_type.
	* unistd.h:  Hacks so it works on AIX (and elsewhere?).

	* sys/wait.h:  Use _G_pid_t where appropriate.
	* unistd.h:  Only define F_OK etc if not already defined.
	* unistd.h:  (Ty) using /usr/include/unistd.h, if available.
	* dirent.h:  If !_G_HAVE_DIRENT, simulatate missing dirent.h
	using <sys/dir.h>.
	* dirent.h:  Don't bother declaring rewinddir - too much of
	a pain, since it is commonly a macro.
	* signal.h:  ssignal functions alwasy return int,
	* stdio.h:  Use new _G_sprint_return_type macro.
	Use _G_va_list instead of inacurate ... (but protect from
	clashes using _G_ARGS).
	* time.h:  Remove use of _G_const.  Use _G_ARGS insted.

Thu May 14 13:24:20 1992  Per Bothner  (bothner@rtl.cygnus.com)

	* sys/socket.h:  Tweak sendto() prototype.
	* sys/stat.h:  Define Posix macros S_ISDIR etc if they're not defined.
	* assert.h:  Include stdio.h for the sake of non-ANSI systems
	(e.g. BSD) whose /usr/include/assert.h need stdio.h.
	* signal.h:  First arg of kill() is a pid_t.
	* stdio.h:  setbuf() and setbuffer() return void.
	Also, add more __hide definitions.

Mon May 11 11:50:03 1992  Per Bothner  (bothner@rtl.cygnus.com)

	* strings.h:  New file.  Just #includes string.h.

Sun May 10 21:49:35 1992  Per Bothner  (bothner@rtl.cygnus.com)

	* curses.h, sys/signal.h:  Add support for "recursive"
	includes (#include_next gets installed previous version,
	which then includes from /usr/include) (for those who don't
	have -nostdinc++).

Wed May  6 01:41:31 1992  Per Bothner  (bothner@rtl.cygnus.com)

	* sys/signal.h:  Add 'hide' for signal().  (Needed on Irix.)
	Also, remove unused __sys_signal_h_recursive junk.

	* curses.h:  Add prototypes for -lcurses functions.

Tue May  5 15:21:07 1992  Per Bothner  (bothner@rtl.cygnus.com)

	* curses.h:  Give up trying to emulate all possible
	curses.h implementations.  Just remove everything,
	and just #include_next <curses.h> instead.

Mon May  4 17:35:04 1992  Per Bothner  (bothner@rtl.cygnus.com)

	* sys/times.h:  Added prototype for times().
	* time.h:  Removed prototype for times().

Fri May  1 00:07:24 1992  Per Bothner  (bothner@rtl.cygnus.com)

	* time.h:  Remove variable declarations, since these will
	presumably be in /usr/include/time.h -otherwise they can't
	be used in C code (without a user declaration) anyway, so
	we won't bothner.  Same applies to the non-SYSV declaration
	of the timezone() function.  Thus we remove some conflicts
	between SYSV and BSD that are impossible to resolve here.

Thu Apr 30 00:39:06 1992  Per Bothner  (bothner@cygnus.com)

	* signal.h:  Comment out sigset, since it seems to be neither
	Posix nor BSD, and causes a conflict on Irix.

	* memory.h, sys/stat.h, signal.h:  Hide all argument lists with
	_G_ARGS macro, to avoid conflicts with system header files.
	* unistd.h: Hide chmod() when doing #next_include.
	* signal.h:  Use _G_signal_return_type to handle systems
	that have signals return int instead of void.
	* sys/resource.h:  Need to #include <_G_config.h>.
	* math.h:  Add fmod().

Fri Apr 17 14:29:04 1992  Per Bothner  (bothner@cygnus.com)

	* Move all libg++-specific header files (e.g. Integer.h) to
	../src. leaving just the header files that are wrapper for
	C header files (e.g. stdio.h).  This allows a system which
	has C++-raedy C header files (with extern "C" if __cplusplus
	defined) (such as SVR4 or Linux) to ignore g++-include.
	* curses.h, time.h:  Replace USG by _G_SYSV, and include
	_G_config.h (which defines _G_SYSV if needed).
	* Various files:  Surround parameter lists by _G_ARGS(...)
	which normally is defined as just (...).  This avoids
	a lot of conflicts with C header files.

Fri Apr 10 22:14:14 1992  Per Bothner  (bothner@cygnus.com)

	* ctype.h:  Simplify to just #include_next <ctype.h>.

Tue Mar 24 16:13:42 1992  Per Bothner  (bothner@rtl.cygnus.com)

	* Rational.h:  Added Rational::fits_in_float() and
	fits_in_double() methods.

Mon Mar 23 16:33:23 1992  Per Bothner  (bothner@rtl.cygnus.com)

	* BitSet.h, BitString.h, Fix.h, Integer,h:  Add printon()
	methods; deprecate *toa functions that use AllocRing.
	(Note ../src/Changes.)

Tue Mar 10 18:21:34 1992  Per Bothner  (bothner@cygnus.com)

	* sys/wait.h:  Don't include sys/resource.h;
	use forward struct declaration instead.

Mon Mar  9 13:26:58 1992  Per Bothner  (bothner@cygnus.com)

	* sys/resource.h:  Backed out recent change (until
	after release) so to again include <sys/time.h>.

Sat Mar  7 18:42:08 1992  Per Bothner  (bothner@rtl.cygnus.com)

	* time.h, sys/time.h, sys/resource.h:  Minor fixes.
	(They allow tests/test_h.cc to compile on DECstation.)

Fri Mar  6 16:25:44 1992  Per Bothner  (bothner@cygnus.com)

	* signal.h:  Protect signal() from conflicts.
	* errno.h:  Onlu declare errno if no errno macro.
	* new.h (operator new):  Don't make static inline, just inline.

Thu Mar  5 23:15:49 1992  Per Bothner  (bothner@cygnus.com)

	Second thoughts about the previous batch of changes to
	handle '#if defined(__OPTIMIZE__) || defined(USE_LIBGXX_INLINES)'.
	The problem was that this constrains how users compile their
	programs:  They have to use -O (or -DUSE_LIBGXX_INLINES).
	They are likely not to, which will cause them (and us) trouble.

	The new solution:  Just remove the #if, and *always* compile
	these functions inline.  This is simple, consistent, and
	understandable.  The disadvantage is that debugging is harder,
	but the answer is to work on being able to debug inline functions.

	* gen/*.hP (almost): Removed all instances of:
	#if defined(__OPTIMIZE__) || defined(USE_LIBGXX_INLINES),
	thus inlining is independent on those flags, as discaussed above,

	* Binomial.h BitSet.h BitString.h ChangeLog Complex.h CursesW.h
	DiscUnif.h Erlang.h Fix.h Fix16.h Fix24.h Geom.h HypGeom.h
	Integer.h LogNorm.h MLCG.h NegExp.h Normal.h Obstack.h Poisson.h
	RNG.h Random.h Rational.h RndInt.h SmplHist.h SmplStat.h String.h
	Uniform.h Weibull.h builtin.h compare.h ctype.h curses.h math.h
	minmax.h:  Undo change from earlier today, and make inlining
	unconditional as above.

Thu Mar  5 16:51:10 1992  Per Bothner  (bothner@cygnus.com)

	* gen/{AVec.ccP,VHSet.ccP,Vec.ccP,Vec.hP}:  Add casts and
	other minor fixes to get rid of compiler warnings.
	* sys/param.h:  Put back #undef of setbit, because it
	would conflict with Integer::Setbit().

	* Binomial.h, BitSet.h, BitString.h, Complex.h, CursesW.h,
	DiscUnif.h, Erlang.h, Fix.h, Fix16.h, Fix24.h, Geom.h, HypGeom.h,
	Integer.h, LogNorm.h, MLCG.h, NegExp.h, Normal.h, Obstack.h,
	Poisson.h, RNG.h, Random.h, Rational.h, RndInt.h, SmplHist.h,
	SmplStat.h, String.h, Uniform.h, Weibull.h, builtin.h, compare.h,
	ctype.h, curses.h, math.h, minmax.h:  No longer use
	USE_LIBGXX_INLINES.  Instead Foo.cc defines _COMPILING_Foo,
	which is used by Foo.h to turn off inlining, thus
	forcing a non-inlined version of those inline functions.
	This allows using libg++ without requiring users to
	compile without -O or setting funny flags.

Tue Mar  3 17:23:53 1992  Per Bothner  (bothner@cygnus.com)

	* BitSet.h:  Move BitSet::clear() from here to BitSet.cc,
	and make non-inlined.

Sun Mar  1 16:08:49 1992  Per Bothner  (bothner@cygnus.com)

	* builtin.h:  Error handler functions are now (again)
	functions returning void, not volatle void, since
	sometimes these error handlers *do* return.
	* BitSet.h, BitString.h, Integer.h, Rational.h, String.h:
	Make error() methods return void, not volatile void.
	* gen/{PHPQ.ccP,PHPQ.hP,Plex.ccP,Plex.hP,VHBag.ccP,VHBag.hP,
	VHMap.ccP,VHMap.hP,VHSet.hP,VOHSet.ccP,VOHSet.hP,VQueue.ccP,
	VQueue.hP,VStack.ccP,VStack.hP,Vec.ccP,Vec.hP}:
	As above, make error methods return void, not volatile void.
	Also, update 'delete [size] foo' to 'delete [] foo'.
	* _G_config.h:  Fix typo in #define of _G_fpos_t.

Wed Feb 26 12:32:08 1992  Per Bothner  (bothner at cygnus.com)

	* _G_config.h:  Add _G_va_list, _G_fpos_t, _G_FOPEN_MAX,
	and _G_FILENAME_MAX.
	* builtin.h:  Use _VOLATILE_VOID macro to define
	function as 'volatile void' only idef __GNUG__.
	* unistd.h:  Add SEEK_SET and F_OK and their friends.
	* sys/mman.h:  Fix typo.
	* gen/SPlayPQ.hP:  Make destructor virtual.

Thu Feb 20 21:47:43 1992  Per Bothner  (bothner at cygnus.com)

	* dirent.h:  Re-write to follow standard pattern
	(instead of just including sys/dir,h).
	* osfcn.h:  Also include sys/types.h.

Wed Feb 19 21:56:37 1992  Per Bothner  (bothner at cygnus.com)

	* stdio.h, time.h, sys/time.h: Renamed c_proto_foo to __hide_foo.
	* _G_config.h:  New file, to contain system-dependent
	parameters.  (Later, this might be a hist-dependent file.)
	* stdio.h:  Got rid of lots of old junk.
	Added a	#define new __hide_new, because AIX uses
	'new' as a parameter name.
	* time.h:  Added some missing prototypes.  Use _G_config.h.

Sat Feb 15 15:32:20 1992  Per Bothner  (bothner at cygnus.com)

	* builtin.h: Remove some obsolete functions (that have been
	moved to ../iostream/stream.h).

Thu Feb  6 16:41:23 1992  Michael Tiemann  (tiemann at cygnus.com)

	* {errno,fcntl,grp,netdb,pwd,setjmp,signal,stdarg,stddef.h}: Make
	these files work correctly with #include_next.
	{stdio,time}.h: Ditto

Wed Feb  5 11:55:57 1992  Per Bothner  (bothner at cygnus.com)

	* time.h, sys/times.h, sys/fcntl.h:  Just #include_next
	the file with the same name; don't include some
	other file (which could cause a loop).

Fri Jan 31 16:55:19 1992  Per Bothner  (bothner at cygnus.com)

	* gen/CHNode.{h,cc}P, gen/SplayNode.{h,cc}.P:  New files.
	Pulled shared definition of CHNode and SplayNode
	classes into their own files, to avoid potential
	linker problems (from duplicated definitions).
	* gen/Splay{Bag,Set,PQ}.hP, gen/CH{Bag,Set}.hP:
	Include {Ch,Splay}Node.hP.

Thu Jan 30 23:50:28 1992  Per Bothner  (bothner at cygnus.com)

	* stdio.h, sys/time.h:  Protect against more function
	prototype conflicts using macro re-naming.
	* stdio.h:  Use size_t (actually __SIZE_TYPE__) where
	appropriate.

Fri Jan 24 15:59:37 1992  Per Bothner  (bothner at cygnus.com)

	* pwd.h, sys/time.h:  Turn #include_next feature on.
	* stdio.h:  Undefine and then redefine NULL, in case
	/usr/include/stdio.h defines NULL without checking
	for an existing definition.
	* sys/signal.h: Don't just #include <signal.h>;
	instead include the system (or _next) <sys/signal.h>,

Fri Jan 17 14:12:54 1992  Per Bothner  (bothner at cygnus.com)

	Merge in Doug Lea's latest version; plus other changes.
	* sys/fcntl.h:  Just include <fcntl.h>.
	* Most sys/*.h files, grp.h, setjmp.h, stdio.h, signal.h,
	stdarg.h, stddef.h:  Use new #include_next feature of cpp
	if using gcc-2.  If so, most of the system-dependent junk
	in stdio.h goes away.
	* dir.h, netdb.h, typemacros.h, sys/dir.h, sys/mman.h:  New files.
	* Various files:  Remove #pragma once (not used by gcc-2).
	* Various files:  Removed #define KERNEL.
	* sys/resources.h, sys/socket.h, sys/wait.h, curses.h,
	fcntl.h:  Add prototypes.
	* BitString.h, String.h:  (int)->(unsigned int) changes (to fix
	some gcc-2 warnings).
	* assert.h, compare.h:  Minor improvements.
	* Integer.h:  Re-do Integer::operator<< to exploit
	new iostream facilities.
	* builtin.h, minmax.h:  Moved min/max from former to latter.
	* builtin.h: Moved hex/oct/dec to ../old-stream/itoa.cc.
	* regex.h:  New version (from FSF).
	* std.h; bstring.h, memory.h, errno.h, string.h, stdlib.h,
	unistd.h:  Move prototypes into separate include files,
	mostly split up the way ANSI C does.
	* abs.h, file.h, malloc.h, max.h, min.h, random.h:  Removed.
